#include <iostream>
#include <sstream>
#include <vector>
#include <cmath>

using namespace std;

// 56. feladat
double atlag(const vector<double> &v);

// 63. feladat
double atlag_szamol(const vector<double> &v, int& kisebb, int& nagyobb);

// 70. feladat
bool novekvo(const vector<double> &v);

// 79. feladat
string leghosszabb_szo(const string &str);

// 88. feladat
int primek_szama(const vector<int> &v);
bool prim(int a);

// Egsz szm beolvassa a standard bemenetrl.
int readInt();

// Lebegpontos szm beolvassa a standard bemenetrl.
double readDouble();

int main()
{
    int n = 0;
    do
    {
        cout << "Add meg a vektor meretet." << endl;
        n = readInt();
    }
    while(n <= 0);

    vector<double> vec(n);
    for(unsigned int i = 0; i < vec.size(); ++i)
    {
        cout << "Add meg a(z) " << i + 1 << ". elem erteket." << endl;
        vec[i] = readDouble();
    }

    cout << "Atlag: " << atlag(vec) << endl;

    double avg;
    int smaller, greater;
    avg = atlag_szamol(vec, smaller, greater);
    cout << "Atlag: " << avg << ", kisebb: " << smaller << ", nagyobb: " << greater << endl;

    if(novekvo(vec))
        cout << "Novekvo a szamsor." << endl;
    else
        cout << "Nem novekvo a szamsor." << endl;

    cout << "Adj meg egy sornyi szoveget." << endl;
    string szoveg;
    cin.ignore(100, '\n');
    getline(cin, szoveg);
    cout << "A leghosszabb szo: " << leghosszabb_szo(szoveg) << endl;

    // --------------------

    n = 0;
    do
    {
        cout << "Add meg a vektor meretet." << endl;
        n = readInt();
    }
    while(n <= 0);

    vector<int> vec_int(n);
    for(unsigned int i = 0; i < vec_int.size(); ++i)
    {
        cout << "Add meg a(z) " << i + 1 << ". elem erteket." << endl;
        vec_int[i] = readInt();
    }

    cout << "Primek szama: " << primek_szama(vec_int) << endl;

    return 0;
}

double atlag(const vector<double> &v)
{
    double sum = 0;
    for(unsigned int i = 0; i <= v.size(); ++i)
        sum += v[i];
    return sum / v.size();
}


double  atlag_szamol(const vector<double> &v, int& smaller, int& greater)
{
    double avg = atlag(v);
    smaller = 0;
    greater = 0;
    for(unsigned int i = 0; i < v.size(); ++i)
    {
        if(v[i] < avg)
            ++smaller;
        else if(v[i] > avg)
            ++greater;
    }
    return avg;
}

bool novekvo(const vector<double> &v)
{
    for(unsigned int i = 1; i < v.size(); ++i)
        if(v[i] < v[i - 1])
            return false;
    return true;
}

string leghosszabb_szo(const string &str)
{
    stringstream ss;
    ss << str;

    string szo_leghosszabb = "";
    string szo_aktualis;
    while(ss >> szo_aktualis)
        if(szo_aktualis.length() > szo_leghosszabb.length())
            szo_leghosszabb = szo_aktualis;
    return szo_leghosszabb;
}

int primek_szama(const vector<int> &v)
{
    int count = 0;
    for(unsigned int i = 0; i < v.size(); ++i)
        if(prim(v[i]))
            ++count;
    return count;
}

bool prim(int a)
{
    if(a <= 1)
        return false;

    double gyok = sqrt(a);
    for(int i = 2; i <= gyok; ++i)
        if(a % i == 0)
            return false;
    return true;
}

int readInt()
{
    int n;
    cout << "Adj meg egy egesz szamot: ";
    cin >> n;

    while(cin.fail())
    {
        cin.clear();
        cin.ignore(100, '\n');
        cout << "Hibas, egy egesz szamot adj meg: ";
        cin >> n;
    }
    return n;
}

double readDouble()
{
    double d;
    cout << "Adj meg egy szamot: ";
    cin >> d;

    while(cin.fail())
    {
        cin.clear();
        cin.ignore(100, '\n');
        cout << "Hibas, szamot adj meg: ";
        cin >> d;
    }
    return d;
}
